//+------------------------------------------------------------------+
//|                                                     MyDECEMA.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "omelette@oceanfree.net"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Yellow

extern int MAperiod = 13;
double DECEMAbuff[],ema1[],ema2[],ema3[],ema4[],ema5[],ema6[],ema7[],ema8[],ema9[],ema10[];
bool FirstPass;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(1);
   SetIndexBuffer(0,DECEMAbuff);
	SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
	
	ArraySetAsSeries(ema1,true);
	ArraySetAsSeries(ema2,true);
	ArraySetAsSeries(ema3,true);
	ArraySetAsSeries(ema4,true);
	ArraySetAsSeries(ema5,true);
	ArraySetAsSeries(ema6,true);
	ArraySetAsSeries(ema7,true);
	ArraySetAsSeries(ema8,true);
	ArraySetAsSeries(ema9,true);
	ArraySetAsSeries(ema10,true);
   
   int BarCount = WindowBarsPerChart();
   
   ArrayResize(ema1,BarCount);
   ArrayResize(ema2,BarCount);
   ArrayResize(ema3,BarCount);
   ArrayResize(ema4,BarCount);
   ArrayResize(ema5,BarCount);
   ArrayResize(ema6,BarCount);
   ArrayResize(ema7,BarCount);
   ArrayResize(ema8,BarCount);
   ArrayResize(ema9,BarCount);
   ArrayResize(ema10,BarCount);
   
   FirstPass = true;	
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   int limit;
   double DECEMA;
//----
   if (counted_bars < 0)
    return(-1);
   else counted_bars++;
   
   limit = Bars - counted_bars;
   
   if (FirstPass == false && limit == 1)
    limit = WindowBarsPerChart();
   
   for (int f=limit; f>=0; f--)
   {
    FirstPass = false;
    
    ema1[f] = iMA(NULL,0,MAperiod,0,MODE_EMA,PRICE_CLOSE,f);
    ema2[f] = iMAOnArray(ema1,0,MAperiod,0,MODE_EMA,f);
    ema3[f] = iMAOnArray(ema2,0,MAperiod,0,MODE_EMA,f);
    ema4[f] = iMAOnArray(ema3,0,MAperiod,0,MODE_EMA,f);
    ema5[f] = iMAOnArray(ema4,0,MAperiod,0,MODE_EMA,f);
    ema6[f] = iMAOnArray(ema5,0,MAperiod,0,MODE_EMA,f);
    ema7[f] = iMAOnArray(ema6,0,MAperiod,0,MODE_EMA,f);
    ema8[f] = iMAOnArray(ema7,0,MAperiod,0,MODE_EMA,f);
    ema9[f] = iMAOnArray(ema8,0,MAperiod,0,MODE_EMA,f);
    ema10[f] = iMAOnArray(ema9,0,MAperiod,0,MODE_EMA,f);
    
    DECEMA = 10*ema1[f]-45*ema2[f]+120*ema3[f]-210*ema4[f]+252*ema5[f]
             -210*ema6[f]+120*ema7[f]-45*ema8[f]+10*ema9[f]-ema10[f];
    DECEMAbuff[f] = DECEMA;

    }
      
//----
   return(0);
  }
//+------------------------------------------------------------------+